// C Source File
// Created 3/26/2003; 9:12:51 PM

#define USE_TI89              // Compile for TI-89

#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 205           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function

void keypress(int *, int *);
void moveship(int *, int);
void detecthit(int *, int *, int *, int *);
void highscores(int *);
void titlescreen(void);

int highscore = 0;
int exitflag = 0;

void _main(void)
{
	again:
	clrscr();
	unsigned short trackpiece[] = {
		0b1111111111111111,
		0b1111111111111111
	};
	unsigned short shipsprite[] = {
		0b0000000110000000,
		0b0000001111000000,
		0b0001001111001000,
		0b0001000110001000,
		0b0001001111001000,
		0b0001111111111000,
		0b0001111001111000,
		0b0000011111100000
	};
	unsigned short erasesprite[] = {
		0b0000000110110000,
		0b0000000000000000
	};
	int i;
	int shipx;
	unsigned short leftwall[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	unsigned short rightwall[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	unsigned short leftwalltemp[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	int hitflag = 0;
	titlescreen();
	if(exitflag == 1) goto quit;
	leftwall[1] = 48;
	rightwall[1] = 96;
	Sprite16 (leftwall[1], 2, 2, trackpiece, LCD_MEM, SPRT_XOR);
	Sprite16 (rightwall[1], 2, 2, trackpiece, LCD_MEM, SPRT_XOR);
	for(i=2; i<51; i++)
	{
		leftwall[i] = leftwall[i-1];
		if(leftwall[i] == 0) leftwall[i] = 0;
		if(leftwall[i] == 81) leftwall[i] = 80;
		rightwall[i] = leftwall[i] + 64;
		Sprite16 (leftwall[i], 2*i, 2, trackpiece, LCD_MEM, SPRT_XOR);
		Sprite16 (rightwall[i], 2*i, 2, trackpiece, LCD_MEM, SPRT_XOR);
	}
	shipx = ((leftwall[50] + rightwall[50]) / 2) - 8; 
	Sprite16 (shipx, 92, 8, shipsprite, LCD_MEM, SPRT_XOR);
	Sprite16 (shipx, 92, 2, erasesprite, LCD_MEM, SPRT_XOR);
	int trueflag = 1;
	int rw, lw, t;
	int score = 0;
	while(trueflag == 1)
	{
		keypress(&shipx, &hitflag);
		for(i=42; i<51; i++) 
		{
			lw = leftwall[i];
			rw = rightwall[i];
			detecthit(&lw, &rw, &shipx, &hitflag);
			leftwall[i] = lw;
			rightwall[i] = rw;
		}
		t = random(3) - 1;
		int u = random(3);
		Sprite16 (leftwall[1], 2, 2, trackpiece, LCD_MEM, SPRT_XOR);
		Sprite16 (rightwall[1], 2, 2, trackpiece, LCD_MEM, SPRT_XOR);
		leftwall[1] = (t*u) + leftwall[1];
		if(leftwall[1] == 0) leftwall[1] = 0;
		if(leftwall[1] == 81) leftwall[1] = 80;
		rightwall[1] = leftwall[1] + 64;
		Sprite16 (leftwall[1], 2, 2, trackpiece, LCD_MEM, SPRT_XOR);
		Sprite16 (rightwall[1], 2, 2, trackpiece, LCD_MEM, SPRT_XOR);
		for(i=1; i<51; i++)
		{
			leftwalltemp[i] = leftwall[i];
		}
		for(i=1; i<51; i++)
		{
			unsigned short trackpiece[] = {
				0b1111111111111111,
				0b1111111111111111
			};
			Sprite16 (rightwall[i]-64, 2*i, 2, trackpiece, LCD_MEM, SPRT_XOR);
			Sprite16 (rightwall[i], 2*i, 2, trackpiece, LCD_MEM, SPRT_XOR);
			leftwall[i+1] = leftwalltemp[i];
			rightwall[i] = leftwall[i] + 64;
			Sprite16 (rightwall[i]-64, 2*i, 2, trackpiece, LCD_MEM, SPRT_XOR);
			Sprite16 (rightwall[i], 2*i, 2, trackpiece, LCD_MEM, SPRT_XOR);
		}
		score++;
		if(hitflag == 1) break;
	}
	while(!(_keytest (RR_ENTER))) {1==1;}
	highscores(&score);
	clrscr();
	goto again;
	quit:
	exitflag = 0;
	return;
}

void titlescreen(void)
{
	FontSetSys (F_8x10);
	printf_xy(30,10,"Corridors 89");
	FontSetSys (F_4x6);
	printf_xy(60,25,"By JcN");
	printf_xy(45,35,"JudeCN@aol.com");
	FontSetSys (F_6x8);
	printf_xy(45,60,"Press Enter");
	FontSetSys (F_4x6);
	printf_xy(0,90,"Current high score:");
	printf_xy(130,90,"%d",highscore);
	int true = 1;
	while(true == 1)
	{
		if(_keytest (RR_ENTER) && (!(_keytest (RR_UP)))) break;
		if(_keytest (RR_CLEAR) && (!(_keytest (RR_UP)))){exitflag = 1; break;}
	}
	clrscr();
}

void keypress(int *shipx, int *hitflag)
{
	if(_keytest (RR_LEFT)) moveship(&(*shipx), -1);
	if(_keytest (RR_RIGHT)) moveship(&(*shipx), 1);
	if(_keytest (RR_CLEAR)) *hitflag = 1;
}

void moveship(int *shipx, int xshift)
{
	unsigned short shipsprite[] = {
		0b0000000110000000,
		0b0000001111000000,
		0b0001001111001000,
		0b0001000110001000,
		0b0001001111001000,
		0b0001111111111000,
		0b0001111001111000,
		0b0000011111100000
	};
	
	Sprite16 (*shipx, 92, 8, shipsprite, LCD_MEM, SPRT_XOR);
	*shipx = *shipx + xshift;
	Sprite16 (*shipx, 92, 8, shipsprite, LCD_MEM, SPRT_XOR);
}

void detecthit(int *lw, int *rw, int *shipx, int *hitflag)
{
		if(*lw + 12 >= *shipx) *hitflag = 1;
		if(*rw <= *shipx + 12) *hitflag = 1;
}

void highscores(int *score)
{
	clrscr();
	FontSetSys (F_8x10);
	printf_xy(0,0,"Corridors 89 Score");
	FontSetSys (F_4x6);
	if(*score > highscore)
	{
		printf_xy(0,20,"Current Score:");
		printf_xy(100,20,"%d", highscore);
		printf_xy(0,50,"Your Score:");
		printf_xy(100,50,"%d", *score);
		printf_xy(30,80,"Nice Piloting!");
		highscore = *score;
	}
	else
	{
		printf_xy(10,42,"You got a high score!");
		printf_xy(20,50,"But not high enough");
	}
	ngetchx();
	ngetchx();
}